---

apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: quantumleap-ld
  name: quantumleap-ld
spec:
  selector:
    matchLabels:
      app: quantumleap-ld
  replicas: 1
  strategy: {}
  template:
    metadata:
      labels:
        app: quantumleap-ld
    spec:
      containers:
      - env:
        - name: LOGLEVEL
          value: "INFO"
        - name: WQ_OFFLOAD_WORK
          value: "false"
        - name: CACHE_QUERIES
          value: "true"
        - name: WORKERS
          value: "6"
        - name: POSTGRES_HOST
          value: {{ timescale_endpoint }}
        - name: POSTGRES_DB_USER
          value: {{ quantumleap_credentials_username }}
        - name: POSTGRES_DB_PASS
          value: {{ quantumleap_credentials_password }}
        - name: POSTGRES_DB_NAME
          value: quantumleap
        - name: POSTGRES_PORT
          value: "5432"
        - name: POSTGRES_USE_SSL
          value: "False"
        - name: QL_DEFAULT_DB
          value: timescale
        - name: USE_GEOCODING
          value: "False"
        imagePullPolicy: IfNotPresent
        image: orchestracities/quantumleap:{{ cm_quantumleap_ld.image_tag }}
        name: quantumleap-ld
        resources:
          requests:
            cpu: "700m"
            memory: "750Mi"
          limits:
            cpu: "1000m"
            memory: 1500Mi
        readinessProbe:
          exec:
            command:
              - "true"
          failureThreshold: 2
          periodSeconds: 2
        livenessProbe:
          initialDelaySeconds: 30
          failureThreshold: 10
          periodSeconds: 60
          timeoutSeconds: 60
          httpGet:
            path: /version
            port: 8668
            scheme: HTTP
        startupProbe:
          initialDelaySeconds: 30
          periodSeconds: 10
          timeoutSeconds: 5
          failureThreshold: 60
          httpGet:
            path: /version
            port: 8668
            scheme: HTTP
        lifecycle:
          postStart:
            exec:
              command:
                - sh
                - '-c'
                - >
                  quantumcron=$(echo '*/1 * * * * for i in {1..4} ; do curl -f
                  http://localhost:8668/v2/notify -H "Content-Type:
                  application/json"
                  -d'"'"'{"subscriptionID":"ping_ld","data":[{"id":"keepalive_ld","type":"ping_ld","one":{"type":"Text","value":"1"}}]}'"'"'
                  && curl -f -X DELETE
                  http://localhost:8668/v2/entities/keepalive_ld; done'); (
                  crontab -l; echo "$quantumcron" ) | crontab -; crond -b;
      restartPolicy: Always
status: {}

---

apiVersion: v1
kind: Service
metadata:
  labels:
    app: quantumleap-ld
  name: quantumleap-ld
spec:
  ports:
  - name: "8668"
    port: 8668
    targetPort: 8668
  selector:
    app: quantumleap-ld
status:
  loadBalancer: {}

---

apiVersion: batch/v1
kind: Job
metadata:
  name: timescaledb-pg-init
spec:
  backoffLimit: 0
  template:
    spec:
      containers:
        - name: timescale
          env:
            - name: QL_DB_INIT_DIR
              value: "/ql-db-init"
            - name: QL_DB_PASS
              value: {{ quantumleap_credentials_password }}
            - name: PG_HOST
              value: {{ timescale_endpoint }}
            - name: PG_PASS
              value: {{ postgres_credentials_password }}
          image: "orchestracities/quantumleap-pg-init:{{ cm_quantumleap_ld.pg_init_image_tag }}"
      restartPolicy: Never
